using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.IO;
using MagSiteLib;

namespace MagSite
{
	/// <summary>
	/// AdminEditDef ̊Tv̐łB
	/// </summary>
	public partial class AdminEditDef : System.Web.UI.Page
	{
		#region Web tH[ fUCiŐꂽR[h 
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: ̌ĂяóAASP.NET Web tH[ fUCiŕKvłB
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// fUCi T|[gɕKvȃ\bhłB̃\bh̓e
		/// R[h GfB^ŕύXȂłB
		/// </summary>
		private void InitializeComponent()
		{    
			this.Init += new System.EventHandler(this.AdminEditDef_Init);

		}
		#endregion

		public string CssUrl = "default.css";

		private string createAlterText( string text )
		{
			return "<br>󗓂ɂꍇ: <strong>" + Server.HtmlEncode(text) + "</strong>";
		}

		private string createAlterMultiLineText( string text )
		{
			System.Text.StringBuilder sb = new System.Text.StringBuilder();
			sb.Append("<br>󗓂ɂꍇ: ");
			StringReader reader = new StringReader(text);
			while( true )
			{
				string s = reader.ReadLine();
				if( s == null ) break;
				sb.Append("<br><strong>" + Server.HtmlEncode(s) + "</strong>");
			}
			return sb.ToString();
		}

		protected void Page_Load(object sender, System.EventArgs e)
		{
			Authorization.ConfirmAccessPermission(User.Identity.Name,URIQueryParser.ParseKeyword(Request.Params));
			FullKeyword keyword = URIQueryParser.ParseKeyword(Request.Params);
			SectionDef def = SectionDefManager.GetSectionDef(keyword);
			this.CssUrl = def.StyleSheetURI;
		}

		protected void AdminEditDef_Init(object sender, System.EventArgs e)
		{
#if KINOLABO
			this.PanelPeruMenu.Visible = false;
#endif
			this.LabelPeruName.Text = SpecialResource.PeruAssociateIDJ;
			FullKeyword keyword = URIQueryParser.ParseKeyword(Request.Params);

			RawSectionDef rawdef = SectionDefManager.GetSectionDef(keyword).GetRawSectionDef();
			SectionDef parentDef = SectionDefManager.GetSectionDef(keyword.GetParentKeyword());

			LabelKeyword.Text = Server.HtmlEncode( WriteLib.KeywordToHumanReadableString(keyword) );
			
			TextBoxTitle.Text = rawdef.Title;
			LabelAlterTitle.Text = createAlterText(parentDef.Title);

			CheckBoxHeaderTextType.Checked = rawdef.HeadTextType == EBodyType.XhtmlByText;

			TextBoxHeadText.Text = rawdef.HeadText;
			LabelAlterHeadText.Text = createAlterMultiLineText(parentDef.HeadText);

			CheckboxFootTextType.Checked = rawdef.FootTextType == EBodyType.XhtmlByText;

			TextBoxFootText.Text = rawdef.FootText;
			LabelAlterFootText.Text = createAlterText(parentDef.FootText);

			TextBoxFootText.Text = rawdef.FootText;
			LabelAlterFootText.Text = createAlterMultiLineText(parentDef.FootText);

			TextBoxSystemMessageTitle.Text = rawdef.SystemMessageTitle;
			LabelAlterSystemMessageTitle.Text = createAlterText(parentDef.SystemMessageTitle);

			TextBoxNewContentsTitle.Text = rawdef.NewContentsTitle;
			LabelAlterNewContentsTitle.Text = createAlterText(parentDef.NewContentsTitle);

			TextBoxTopContentsTitle.Text = rawdef.TopContentsTitle;
			LabelAlterTopContentsTitle.Text = createAlterText(parentDef.TopContentsTitle);

			TextBoxTopKeywordsTitle.Text = rawdef.TopKeywordsTitle;
			LabelAlterTopKeywordsTitle.Text = createAlterText(parentDef.TopKeywordsTitle);

			TextBoxChildKeywordsTitle.Text = rawdef.ChildKeywordsTitle;
			LabelAlterChildKeywordsTitle.Text = createAlterText(parentDef.ChildKeywordsTitle);

			TextBoxContentsListTitle.Text = rawdef.ContentsListTitle;
			LabelAlterContentsListTitle.Text = createAlterText(parentDef.ContentsListTitle);

			TextBoxLinkTitle.Text = rawdef.LinkTitle;
			LabelAlterLinkTitle.Text = createAlterText(parentDef.LinkTitle);

			TextBoxAdminstratorMailAddress.Text = rawdef.AdminstratorMailAddress;
			LabelAlterAdminstratorMailAddress.Text = createAlterText(parentDef.AdminstratorMailAddress);

			TextBoxTitlePictureURI.Text = rawdef.TitlePictureURI;
			LabelAlterTitlePictureURI.Text = createAlterText(parentDef.TitlePictureURI);

			TextBoxStyleSheetURI.Text = rawdef.StyleSheetURI;
			LabelAlterStyleSheetURI.Text = createAlterText(parentDef.StyleSheetURI);

			TextBoxAdminstratorName.Text = rawdef.AdminstratorName;
			LabelAlterAdminstratorName.Text = createAlterText(parentDef.AdminstratorName);

			TextBoxAutoReportMailAddress.Text = rawdef.AutoReportMailAddress;
			LabelAlterAutoReportMailAddress.Text = createAlterText(parentDef.AutoReportMailAddress);

			TextBoxSmtpServerHostName.Text = rawdef.SmtpServerHostName;
			LabelAlterSmtpServerHostName.Text = createAlterText(parentDef.SmtpServerHostName);

            TextBoxSmtpServerPortNumber.Text = rawdef.SmtpServerPortNumber;
            LabelAlterSmtpServerPortNumber.Text = createAlterText(parentDef.SmtpServerPortNumber.ToString());

            TextBoxSmtpServerUserId.Text = rawdef.SmtpServerUserId;
            LabelAlterSmtpServerUserId.Text = createAlterText(parentDef.SmtpServerUserId);

            TextBoxSmtpServerUserPassword.Text = rawdef.SmtpServerUserPassword;
            LabelAlterSmtpServerUserPassword.Text = createAlterText(parentDef.SmtpServerUserPassword);

            TextBoxPopServerHostName.Text = rawdef.PopServerHostName;
            LabelAlterPopServerHostName.Text = createAlterText(parentDef.PopServerHostName);

            TextBoxPopServerPortNumber.Text = rawdef.PopServerPortNumber;
            LabelAlterPopServerPortNumber.Text = createAlterText(parentDef.PopServerPortNumber.ToString());

            TextBoxPopServerUserId.Text = rawdef.PopServerUserId;
            LabelAlterPopServerUserId.Text = createAlterText(parentDef.PopServerUserId);

            TextBoxPopServerUserPassword.Text = rawdef.PopServerUserPassword;
            LabelAlterPopServerUserPassword.Text = createAlterText(parentDef.PopServerUserPassword);

            TextBoxPeruAssociateID.Text = rawdef.PeruAssociateID;
			LabelAlterPeruAssociateID.Text = createAlterText(parentDef.PeruAssociateID);

            TextBoxValueCommerceSiteId.Text = rawdef.ValueCommerceSiteId;
            LabelValueCommerceSiteId.Text = createAlterText(parentDef.ValueCommerceSiteId);

            TextBoxValueCommerceToken.Text = rawdef.ValueCommerceToken;
            LabelValueCommerceToken.Text = createAlterText(parentDef.ValueCommerceToken);

            TextBoxGoogleAdSenseID.Text = rawdef.GoogleAdSenseID;
			LabelGoogleAdSenseID.Text = createAlterText(parentDef.GoogleAdSenseID);

            TextBoxGoogleAdSenseSlot.Text = rawdef.GoogleAdSenseSlot;
            LabelGoogleAdSenseSlot.Text = createAlterText(parentDef.GoogleAdSenseSlot);

			TextBoxGamerTag.Text = rawdef.GamerTag;
			LabelGamerTag.Text = createAlterText(parentDef.GamerTag);

			TextBoxGoogleMapsKey.Text = rawdef.GoogleMapsKey;
			LabelGoogleMapsKey.Text = createAlterText(parentDef.GoogleMapsKey);

            CheckBoxHideHyosi.Checked = rawdef.HideHyosi;

			TextBoxShortKeyword.Text = rawdef.ShortKeyword;
		}

		private void RedirectResult(string message,FullKeyword keyword)
		{
			System.Text.StringBuilder sb = new System.Text.StringBuilder();
			sb.Append(FileNames.AdminFn);
			sb.Append("?msg=");
			sb.Append(Server.UrlEncode(message));
			sb.Append("&kw=");
			sb.Append(Server.UrlEncode(keyword.EncodedKeyword));
			Response.Redirect(sb.ToString());
		}

		protected void ButtonSubmit_Click(object sender, System.EventArgs e)
		{
			FullKeyword keyword = URIQueryParser.ParseKeyword(Request.Params);
			
			RawSectionDef rawdef = SectionDefManager.GetSectionDef(keyword).GetRawSectionDef();
			
			rawdef.Title = TextBoxTitle.Text;
			rawdef.HeadTextType = this.CheckBoxHeaderTextType.Checked ? EBodyType.XhtmlByText : EBodyType.PlaneText;

			rawdef.HeadText = TextBoxHeadText.Text;
			rawdef.FootTextType = this.CheckboxFootTextType.Checked ? EBodyType.XhtmlByText : EBodyType.PlaneText;
			rawdef.FootText = TextBoxFootText.Text;
			rawdef.SystemMessageTitle = TextBoxSystemMessageTitle.Text;
			rawdef.NewContentsTitle = TextBoxNewContentsTitle.Text;
			rawdef.TopContentsTitle = TextBoxTopContentsTitle.Text;
			rawdef.TopKeywordsTitle = TextBoxTopKeywordsTitle.Text;
			rawdef.ChildKeywordsTitle = TextBoxChildKeywordsTitle.Text;
			rawdef.ContentsListTitle = TextBoxContentsListTitle.Text;
			rawdef.LinkTitle = TextBoxLinkTitle.Text;
			rawdef.AdminstratorMailAddress = TextBoxAdminstratorMailAddress.Text;
			rawdef.TitlePictureURI = TextBoxTitlePictureURI.Text;
			rawdef.StyleSheetURI = TextBoxStyleSheetURI.Text;
			rawdef.AdminstratorName = TextBoxAdminstratorName.Text;
			rawdef.SmtpServerHostName = TextBoxSmtpServerHostName.Text;
            rawdef.SmtpServerPortNumber = TextBoxSmtpServerPortNumber.Text;
            rawdef.SmtpServerUserId = TextBoxSmtpServerUserId.Text;
            rawdef.SmtpServerUserPassword = TextBoxSmtpServerUserPassword.Text;
            rawdef.PopServerHostName = TextBoxPopServerHostName.Text;
            rawdef.PopServerPortNumber = TextBoxPopServerPortNumber.Text;
            rawdef.PopServerUserId = TextBoxPopServerUserId.Text;
            rawdef.PopServerUserPassword = TextBoxPopServerUserPassword.Text;
            rawdef.AutoReportMailAddress = TextBoxAutoReportMailAddress.Text;
			rawdef.PeruAssociateID = TextBoxPeruAssociateID.Text;
            rawdef.ValueCommerceSiteId = TextBoxValueCommerceSiteId.Text;
            rawdef.ValueCommerceToken = TextBoxValueCommerceToken.Text;
            rawdef.GoogleAdSenseID = TextBoxGoogleAdSenseID.Text;
            rawdef.GoogleAdSenseSlot = TextBoxGoogleAdSenseSlot.Text;
            rawdef.GamerTag = TextBoxGamerTag.Text;
			rawdef.GoogleMapsKey = TextBoxGoogleMapsKey.Text;
            rawdef.HideHyosi = CheckBoxHideHyosi.Checked;

			if( rawdef.ShortKeyword != TextBoxShortKeyword.Text )
			{
				if( TextBoxShortKeyword.Text!= "" && ShortKeywordFinder.IsShortKeyword( TextBoxShortKeyword.Text ) )
				{
					RedirectResult("ZO [" + TextBoxShortKeyword.Text
						+ "] ͊ɎgpĂ܂BWebuEÚu߂v{^Ŗ߂ĕύXĉB",
						keyword);
					return;
				}
			}
			rawdef.ShortKeyword = TextBoxShortKeyword.Text;
			rawdef.Update();

			RedirectResult("ύX܂B",keyword);
		}
	}
}
