﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Services;
using MagSiteLib;

namespace MagSite2
{
    /// <summary>
    /// AdminWebService の概要の説明です
    /// </summary>
    [WebService(Namespace = "http://www.piedey.co.jp/ms/magsite2/admin/ws/")]
    [WebServiceBinding(ConformsTo = WsiProfiles.BasicProfile1_1)]
    [System.ComponentModel.ToolboxItem(false)]
    // この Web サービスを、スクリプトから ASP.NET AJAX を使用して呼び出せるようにするには、次の行のコメントを解除します。 
    // [System.Web.Script.Services.ScriptService]
    public class AdminWebService : System.Web.Services.WebService
    {
        /// <summary>
        /// コンテンツを追加する
        /// </summary>
        /// <param name="xmlcol"></param>
        /// <param name="accessCount"></param>
        /// <returns>追加成功ならnull, 文字列なら追加できなかった理由</returns>
        [WebMethod]
        public string AddContents(string keyword, string itemID, string rootShortKeyword, string xmlcol, int accessCount)
        {
            return General.AddItemFromWebService(new FullKeyword(keyword), new ItemID(itemID), rootShortKeyword, xmlcol, accessCount);
        }

        //[WebMethod]
        //public string HelloWorld()
        //{
        //    return "Hello World";
        //}
    }
}
